/**
 * Created by cyril on 07/09/15.
 */


    document.getElementById('dependency').innerHTML += toSVG();

    $(".mode").change(function () {
        var url = "/lavoisier/dependencies?";
        $(".mode").each(function () {
            url += $(this).attr("id") + "=" + $(this).is(':checked') + "&";
        });
        url = url.slice(0, -1);
        self.location.href = url;
    });

    function createPluginBlocks() {
        $("g.node").each(function () {
            var color =  [];
            color["C"] = "#6cbddf";
            color["S"] = '#66c89d';
            color["V"] = "#e5a4f5";
            color["P"] = '#efefef';
            color["K"] = '#fbbf58';
            color["T"] = '#fbbf58';

            var sequence = $($(this).attr("id").split("_"))[0].split("");
            var i = 0;
            $(this).find("text:gt(0)").each(function () {
                var parentBox = $(this).prev("polyline").get(0).getBBox();
                if ($(this).next("polyline").get(0)) {
                    var tmp = $(this).next("polyline").get(0).getBBox();
                    parentBox.height = tmp.y - parentBox.y;
                } else {
                    var tmp = $(this).prevAll("polygon").get(0).getBBox();
                    parentBox.height = tmp.height + tmp.y - parentBox.y;
                }
                createBlock($(this).get(0), color[sequence[i]], parentBox);
                i++;
            });
        });
    }

    /**
     * Fonction qui crée la boite derrière un élément texte
     **/
    function createBlock(textElem, color, parentBox) {
        var SVGRect = textElem.getBBox();
        var rect = document.createElementNS("http://www.w3.org/2000/svg", "rect");
        rect.setAttribute("class", "block");
        rect.setAttribute("x", parentBox.x + 0.5);
        rect.setAttribute("y", parentBox.y + 0.5);
        rect.setAttribute("width", parentBox.width - 1);
        rect.setAttribute("height", parentBox.height - 1);
        rect.setAttribute("fill", color);
        $(rect).insertBefore(textElem);
    }

    /**
     * Décplacement du lien 'a' racine vers le 1er 'text' trouvé
     */
    function createHyperLinks() {

        // On déplace tous les "g > a > *" à la racine de "g", donc "a" devient orphelin
        $("g.node").find("a").find("*").each(function () {
            $(this).clone().appendTo($(this).closest("g"));
            $(this).remove();
        });

        // On créer le lien sur le nom du plugin
        $("g.node").find("text:lt(1)").each(function () {
            $(this).css("font-style", "italic");
            $(this).wrap($(this).siblings("a"));
            $(this).closest("a").attr("xlink:title", "View");
        });

        // On crée des liens pour tous les aurtes blocks du plugin
        $("g.node").each(function () {


            var plugin = [];
            plugin["C"] = "Connector";
            plugin["S"] = "Serializer";
            plugin["V"] = "Validator";
            plugin["P"] = "Processor";
            plugin["K"] = "Cache";
            plugin["T"] = "Trigger";


            var sequence = $($(this).attr("id").split("_"))[0].split("");
            var i = 0;
            $(this).find("text:gt(0)").each(function () {
                $(this).wrap($(this).siblings("a"));
                $(this).closest("a").attr("xlink:href", ($(this).closest("a").attr("xlink:href") + "#" + (i + 1)));
                $(this).closest("a").attr("xlink:title", plugin[sequence[i]]);
                i++;
            });
        });

        // On supprime le g > a orphelin
        $("g.node").each(function () {
            $(this).find("a").first().remove();
        });
    }

    function printStackTrace(s) {
        return  s.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;") ;
    }

    function toSVG() {
        try {
            return Viz(document.getElementById("dot").innerHTML, "svg");
        } catch (e) {
            return printStackTrace(e.toString());
        }
    }
